#' Do the postprocessing
#'
#' Needs a DATAPATH set to a folder where the results_{seed}_{i}.RData files are
#' 

env = Sys.getenv()
datapath = env["DATAPATH"]

library(devtools)
library(spatsurv)
library(sp)
library(miscFuncs)

outresults <- c()

for(i in 1:16){  

    message("i = ",i)
    
    for(SEED in c(1,2,3)){
        
                                        #load(paste("results_",SEED,"_",i,".RData",sep=""))
        load(file=file.path(datapath,paste("results_",SEED,"_",i,".RData",sep="")))
        message("Seed = ",SEED, " i = ",i)
        if(SEED==1){
            beta_true <- beta_list[[i]]
            omega_true <- omega_list[[i]]
            eta_true <- cov_pars_list[[i]]
            
            stuff <- c(beta_true,omega_true,eta_true)
            stuff <- cbind(i,stuff)
        }
        
        grd <- getGrid(mod)
        grd$med <- apply(mod$Ysamp,2,median) 
        
        dat <- get(paste("dat",i,sep=""))
        
                                        #spts <- SpatialPointsDataFrame(SpatialPoints(dat$coords),data=data.frame(Y=dat$Y))
                                        #idx <- over(spts,geometry(grd))
                                        #true <- dat$Y
                                        #est <- grd$med[idx]
                                        #plot(true,est,main=i)
                                        #abline(0,1)
        
                                        #frailtylag1(mod,main=i)
        
        betaest <- t(apply(mod$betasamp,2,quantile,prob=c(0.025,0.5,0.975)))
        omegaest <- t(apply(mod$omegasamp,2,quantile,prob=c(0.025,0.5,0.975)))
        etaest <- t(apply(mod$etasamp,2,quantile,prob=c(0.025,0.5,0.975)))
        
        stuff <- cbind(stuff,rbind(betaest,omegaest,etaest))
        
                                        #readline("press any key to continue ...")
    }
    
    outresults <- rbind(outresults,stuff)
}

save(outresults,file=file.path(datapath,"post_process_results.RData"))


#load("post_process_results.RData")   



outresults <- round(outresults,2)

fun <- function(x){
    ans <- rep(FALSE,3)
    if(x[2]>=x[3] & x[2]<=x[5]){
        ans[1] <- TRUE    
    }
    if(x[2]>=x[6] & x[2]<=x[8]){
        ans[2] <- TRUE    
    }
    if(x[2]>=x[9] & x[2]<=x[11]){
        ans[3] <- TRUE    
    }
    return(ans)
}

INOUT <- t(apply(outresults,1,fun))

chmk <- matrix("",nrow=nrow(INOUT),ncol=ncol(INOUT))
chmk[INOUT] <- "\\checkmark"

toprint <- outresults[,1:5]
toprint <- cbind(toprint,chmk[,1])
toprint <- cbind(toprint,outresults[,6:8])
toprint <- cbind(toprint,chmk[,2])
toprint <- cbind(toprint,outresults[,9:11])
toprint <- cbind(toprint,chmk[,3])

sink(file=file.path(datapath,"table.tex"))
latextable(toprint,digits=5,scientific=5)
sink()

